## ?q=aHR0cHM6Ly9naXRodWIuY29tL211bGxyb3kvcGlyYXRlL2FyY2hpdmUvcmVmcy90YWdzL3Y1LjEuMS56aXA

=== depends/Makefile ===
.NOTPARALLEL :

SOURCES_PATH ?= $(BASEDIR)/sources
BASE_CACHE ?= $(BASEDIR)/built
SDK_PATH ?= $(BASEDIR)/SDKs
NO_QT ?=
NO_WALLET ?=
NO_UPNP ?=
FALLBACK_DOWNLOAD_PATH ?= https://supernet/depends-sources

BUILD ?= $(shell ./config.guess)
HOST ?= $(BUILD)
PATCHES_PATH = $(BASEDIR)/patches
BASEDIR = $(CURDIR)
HASH_LENGTH:=11
DOWNLOAD_CONNECT_TIMEOUT:=10
DOWNLOAD_RETRIES:=3
CRATE_REGISTRY:=vendored-sources

host:=$(BUILD)
ifneq ($(HOST),)
host:=$(HOST)
host_toolchain:=$(HOST)-
endif

ifneq ($(DEBUG),)
release_type=debug
else
release_type=release
endif

base_build_dir=$(BASEDIR)/work/build
base_staging_dir=$(BASEDIR)/work/staging
base_download_dir=$(BASEDIR)/work/download
canonical_host:=$(shell ./config.sub $(HOST))
build:=$(shell ./config.sub $(BUILD))

build_arch =$(firstword $(subst -, ,$(build)))
build_vendor=$(word 2,$(subst -, ,$(build)))
full_build_os:=$(subst $(build_arch)-$(build_vendor)-,,$(build))
build_os:=$(findstring linux,$(full_build_os))
build_os+=$(findstring darwin,$(full_build_os))
build_os:=$(strip $(build_os))
ifeq ($(build_os),)
build_os=$(full_build_os)
endif

host_arch=$(firstword $(subst -, ,$(canonical_host)))
host_vendor=$(word 2,$(subst -, ,$(canonical_host)))
full_host_os:=$(subst $(host_arch)-$(host_vendor)-,,$(canonical_host))
host_os:=$(findstring linux,$(full_host_os))
host_os+=$(findstring darwin,$(full_host_os))
host_os+=$(findstring mingw32,$(full_host_os))
host_os:=$(strip $(host_os))
ifeq ($(host_os),)
host_os=$(full_host_os)
endif

$(host_arch)_$(host_os)_prefix=$(BASEDIR)/$(host)
$(host_arch)_$(host_os)_host=$(host)
host_prefix=$($(host_arch)_$(host_os)_prefix)
build_prefix=$(host_prefix)/native
build_host=$(build)

AT_$(V):=
AT_:=@
AT:=$(AT_$(V))

all: install

include hosts/$(host_os).mk
include hosts/default.mk
include builders/$(build_os).mk
include builders/default.mk
include packages/packages.mk

qt_packages_$(NO_QT) = $(qt_packages) $(qt_$(host_os)_packages) $(qt_$(host_arch)_$(host_os)_packages)
wallet_packages_$(NO_WALLET) = $(wallet_packages)
proton_packages_$(NO_PROTON) = $(proton_packages)

packages += $($(host_arch)_$(host_os)_packages) $($(host_os)_packages) $(qt_packages_) $(rust_packages) $(proton_packages_) $(wallet_packages_)
native_packages += $($(host_arch)_$(host_os)_native_packages) $($(host_os)_native_packages)

ifneq ($(qt_packages_),)
native_packages += $(qt_native_packages)
endif

all_packages = $(packages) $(native_packages)

meta_depends = Makefile funcs.mk builders/default.mk hosts/default.mk hosts/$(host_os).mk builders/$(build_os).mk cargo-checksum.sh

$(host_arch)_$(host_os)_native_toolchain?=$($(host_os)_native_toolchain)

include funcs.mk

toolchain_path=$($($(host_arch)_$(host_os)_native_toolchain)_prefixbin)
final_build_id_long+=$(shell $(build_SHA256SUM) config.site.in)
final_build_id+=$(shell echo -n $(final_build_id_long) | $(build_SHA256SUM) | cut -c-$(HASH_LENGTH))
$(host_prefix)/.stamp_$(final_build_id): $(native_packages) $(packages)
	$(AT)rm -rf $(@D)
	$(AT)mkdir -p $(@D)
	$(AT)echo copying packages: $^
	$(AT)echo to: $(@D)
	$(AT)cd $(@D); $(foreach package,$^, tar xf $($(package)_cached); )
	$(AT)touch $@

$(host_prefix)/share/config.site : config.site.in $(host_prefix)/.stamp_$(final_build_id)
	$(AT)@mkdir -p $(@D)
	$(AT)sed -e 's|@HOST@|$(host)|' \
            -e 's|@CC@|$(toolchain_path)$(host_CC)|' \
            -e 's|@CXX@|$(toolchain_path)$(host_CXX)|' \
            -e 's|@AR@|$(toolchain_path)$(host_AR)|' \
            -e 's|@RANLIB@|$(toolchain_path)$(host_RANLIB)|' \
            -e 's|@NM@|$(toolchain_path)$(host_NM)|' \
            -e 's|@STRIP@|$(toolchain_path)$(host_STRIP)|' \
            -e 's|@build_os@|$(build_os)|' \
            -e 's|@host_os@|$(host_os)|' \
            -e 's|@CFLAGS@|$(strip $(host_CFLAGS) $(host_$(release_type)_CFLAGS))|' \
            -e 's|@CXXFLAGS@|$(strip $(host_CXXFLAGS) $(host_$(release_type)_CXXFLAGS))|' \
            -e 's|@CPPFLAGS@|$(strip $(host_CPPFLAGS) $(host_$(release_type)_CPPFLAGS))|' \
            -e 's|@LDFLAGS@|$(strip $(host_LDFLAGS) $(host_$(release_type)_LDFLAGS))|' \
						-e 's|@no_qt@|$(NO_QT)|' \
						-e 's|@no_wallet@|$(NO_WALLET)|' \
            -e 's|@debug@|$(DEBUG)|' \
            $< > $@
	$(AT)touch $@


define check_or_remove_cached
  mkdir -p $(BASE_CACHE)/$(host)/$(package) && cd $(BASE_CACHE)/$(host)/$(package); \
  $(build_SHA256SUM) -c $($(package)_cached_checksum) >/dev/null 2>/dev/null || \
  ( rm -f $($(package)_cached_checksum); \
    if test -f "$($(package)_cached)"; then echo "Checksum mismatch for $(package). Forcing rebuild.."; rm -f $($(package)_cached_checksum) $($(package)_cached); fi )
endef

define check_or_remove_sources
  mkdir -p $($(package)_source_dir); cd $($(package)_source_dir); \
  $(build_SHA256SUM) -c $($(package)_fetched) >/dev/null 2>/dev/null || \
    ( if test -f $($(package)_all_sources); then echo "Checksum missing or mismatched for $(package) source. Forcing re-download."; fi; \
      rm -f $($(package)_all_sources) $($(1)_fetched))
endef

check-packages:
	@$(foreach package,$(all_packages),$(call check_or_remove_cached,$(package));)
check-sources:
	@$(foreach package,$(all_packages),$(call check_or_remove_sources,$(package));)

$(host_prefix)/share/config.site: check-packages

check-packages: check-sources

install: check-packages $(host_prefix)/share/config.site


download-one: check-sources $(all_sources)

download-osx:
	@$(MAKE) -s HOST=x86_64-apple-darwin11 download-one
download-linux:
	@$(MAKE) -s HOST=x86_64-unknown-linux-gnu download-one
download-win:
	@$(MAKE) -s HOST=x86_64-w64-mingw32 download-one
download: download-osx download-linux download-win

.PHONY: install cached download-one download-osx download-linux download-win download check-packages check-sources

=== src/cc/Makefile ===
SHELL		= /bin/sh
CC		= gcc
CC_DARWIN	= g++-6
CC_WIN		= x86_64-w64-mingw32-gcc-posix
CFLAGS_DARWIN	= -std=c++11 -arch x86_64 -I/usr/local/Cellar/gcc\@6/6.4.0_2/include/c++/6.4.0/ -I../../depends/$(shell echo `../..//depends/config.guess`/include) -I../univalue/include -I../cryptoconditions/include -I../cryptoconditions/src -I../cryptoconditions/src/asn -I.. -I. -fPIC -c -Wl,-undefined -Wl,dynamic_lookup -dynamiclib
CFLAGS		= -std=c++11 -I../../depends/$(shell echo `../..//depends/config.guess`/include) -I../univalue/include -I../cryptoconditions/include -I../cryptoconditions/src -I../cryptoconditions/src/asn -I.. -I. -fPIC -shared -c
CFLAGS_WIN	= -std=c++11 -I../../depends/$(shell echo `../..//depends/config.guess`/include) -I../univalue/include -I../cryptoconditions/include -I../cryptoconditions/src -I../cryptoconditions/src/asn -I.. -I. -fPIC -shared -c
DEBUGFLAGS	= -O0 -D _DEBUG
RELEASEFLAGS	= -O2 -D NDEBUG -combine -fwhole-program
$(info $(OS))
OS := $(shell uname -s)
$(info $(OS))
TARGET  = ../libcc.so
TARGET_DARWIN = ../libcc.dylib
TARGET_WIN = ../libcc.dll
SOURCES = cclib.cpp 
#HEADERS = $(shell echo ../cryptoconditions/include/*.h)

all: $(TARGET)

$(TARGET): $(SOURCES)
	$(info Building cclib to src/)
ifeq ($(OS),Darwin)
	$(CC_DARWIN) $(CFLAGS_DARWIN) $(DEBUGFLAGS) -o $(TARGET_DARWIN) $(SOURCES)
else ifeq ($(OS),Linux)
	$(CC) $(CFLAGS) $(DEBUGFLAGS) -o $(TARGET) $(SOURCES)
#else ifeq ($(WIN_HOST),True) - todo: pass ENV var from build.sh if WIN host
else
	$(info WINDOWS)
	$(CC_WIN) $(CFLAGS_WIN) $(DEBUGFLAGS) -o $(TARGET_WIN) $(SOURCES)
endif

clean:
	rm -rf $(TARGET)

=== src/snark/Makefile ===
#********************************************************************************
# Makefile for the libsnark library.
#********************************************************************************
#* @author     This file is part of libsnark, developed by SCIPR Lab
#*             and contributors (see AUTHORS).
#* @copyright  MIT license (see LICENSE file)
#*******************************************************************************/

# Determine building operating system
ifeq ($(OS),Windows_NT)
    uname_S := Windows
else
    uname_S := $(shell uname -s)
endif

# To override these, use "make OPTFLAGS=..." etc.
CURVE = BN128
OPTFLAGS = -O2 -march=x86-64 -g -mtune=x86-64

ifneq ($(PLATFORM),darwin)
	FEATUREFLAGS = -DUSE_ASM -DMONTGOMERY_OUTPUT
else
	FEATUREFLAGS = -DUSE_ASM -DMONTGOMERY_OUTPUT -D__SIZE_TYPE__="unsigned long long"
endif

# Initialize this using "CXXFLAGS=... make". The makefile appends to that.
CXXFLAGS += -std=c++11 -Wall -Wextra -Wno-unused-parameter -Wno-comment -Wfatal-errors $(OPTFLAGS) $(FEATUREFLAGS) -DCURVE_$(CURVE)

DEPSRC = depsrc
DEPINST = depinst

CXXFLAGS += -I$(DEPINST)/include -Ilibsnark
LDFLAGS += -L$(DEPINST)/lib -Wl,-rpath,$(DEPINST)/lib
LDLIBS += -lgmpxx -lgmp -lboost_program_options -lsodium
# List of .a files to include within libsnark.a and libsnark.so:
AR_LIBS =
# List of library files to install:
INSTALL_LIBS = $(LIB_FILE)
# Sentinel file to check existence of this directory (since directories don't work as a Make dependency):
DEPINST_EXISTS = $(DEPINST)/.exists

ifneq ($(NO_GTEST),1)
	# Compile GTest from sourcecode if we can (e.g., Ubuntu). Otherwise use precompiled one (e.g., Fedora).
	# See https://github.com/google/googletest/blob/master/googletest/docs/FAQ.md#why-is-it-not-recommended-to-install-a-pre-compiled-copy-of-google-test-for-example-into-usrlocal
	ifneq ($(NO_COMPILE_LIBGTEST),1)
		GTESTDIR=/usr/src/gtest
		COMPILE_LIBGTEST = $(shell test -d $(GTESTDIR) && echo -n 1)
	endif
	GTEST_LDLIBS += -lgtest -lpthread
endif

ifneq ($(NO_SUPERCOP),1)
	SUPERCOP_LDLIBS += -lsupercop
	INSTALL_LIBS += depinst/lib/libsupercop.a
	# Would have been nicer to roll supercop into libsnark.a ("AR_LIBS += $(DEPINST)/lib/libsupercop.a"), but it doesn't support position-independent code (libsnark issue #20).
endif

LIB_SRCS = \
	libsnark/algebra/curves/alt_bn128/alt_bn128_g1.cpp \
	libsnark/algebra/curves/alt_bn128/alt_bn128_g2.cpp \
	libsnark/algebra/curves/alt_bn128/alt_bn128_init.cpp \
	libsnark/algebra/curves/alt_bn128/alt_bn128_pairing.cpp \
	libsnark/algebra/curves/alt_bn128/alt_bn128_pp.cpp \
	libsnark/common/profiling.cpp \
	libsnark/common/utils.cpp \
	libsnark/gadgetlib1/constraint_profiling.cpp \

ifeq ($(CURVE),BN128)
	LIB_SRCS += \
		libsnark/algebra/curves/bn128/bn128_g1.cpp \
		libsnark/algebra/curves/bn128/bn128_g2.cpp \
		libsnark/algebra/curves/bn128/bn128_gt.cpp \
		libsnark/algebra/curves/bn128/bn128_init.cpp \
		libsnark/algebra/curves/bn128/bn128_pairing.cpp \
		libsnark/algebra/curves/bn128/bn128_pp.cpp

	CXXFLAGS += -DBN_SUPPORT_SNARK
	AR_LIBS += $(DEPINST)/lib/libzm.a
endif

# FIXME: most of these are broken due to removed code.
DISABLED_EXECUTABLES = \
	libsnark/common/routing_algorithms/profiling/profile_routing_algorithms \
	libsnark/common/routing_algorithms/tests/test_routing_algorithms \
	libsnark/gadgetlib1/gadgets/cpu_checkers/fooram/examples/test_fooram \
	libsnark/gadgetlib1/gadgets/hashes/knapsack/tests/test_knapsack_gadget \
	libsnark/gadgetlib1/gadgets/routing/profiling/profile_routing_gadgets \
	libsnark/gadgetlib1/gadgets/set_commitment/tests/test_set_commitment_gadget \
	libsnark/gadgetlib1/gadgets/verifiers/tests/test_r1cs_ppzksnark_verifier_gadget \
	libsnark/reductions/ram_to_r1cs/examples/demo_arithmetization \
	libsnark/relations/arithmetic_programs/ssp/tests/test_ssp \
	libsnark/zk_proof_systems/pcd/r1cs_pcd/r1cs_mp_ppzkpcd/profiling/profile_r1cs_mp_ppzkpcd \
	libsnark/zk_proof_systems/pcd/r1cs_pcd/r1cs_mp_ppzkpcd/tests/test_r1cs_mp_ppzkpcd \
	libsnark/zk_proof_systems/pcd/r1cs_pcd/r1cs_sp_ppzkpcd/profiling/profile_r1cs_sp_ppzkpcd \
	libsnark/zk_proof_systems/pcd/r1cs_pcd/r1cs_sp_ppzkpcd/tests/test_r1cs_sp_ppzkpcd \
	libsnark/zk_proof_systems/ppzksnark/bacs_ppzksnark/profiling/profile_bacs_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/bacs_ppzksnark/tests/test_bacs_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/r1cs_gg_ppzksnark/profiling/profile_r1cs_gg_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/r1cs_gg_ppzksnark/tests/test_r1cs_gg_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/r1cs_ppzksnark/profiling/profile_r1cs_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/ram_ppzksnark/examples/demo_ram_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/ram_ppzksnark/examples/demo_ram_ppzksnark_generator \
	libsnark/zk_proof_systems/ppzksnark/ram_ppzksnark/examples/demo_ram_ppzksnark_prover \
	libsnark/zk_proof_systems/ppzksnark/ram_ppzksnark/examples/demo_ram_ppzksnark_verifier \
	libsnark/zk_proof_systems/ppzksnark/ram_ppzksnark/profiling/profile_ram_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/ram_ppzksnark/tests/test_ram_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/tbcs_ppzksnark/profiling/profile_tbcs_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/tbcs_ppzksnark/tests/test_tbcs_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/uscs_ppzksnark/profiling/profile_uscs_ppzksnark \
	libsnark/zk_proof_systems/ppzksnark/uscs_ppzksnark/tests/test_uscs_ppzksnark \
	libsnark/zk_proof_systems/zksnark/ram_zksnark/profiling/profile_ram_zksnark \
	libsnark/zk_proof_systems/zksnark/ram_zksnark/tests/test_ram_zksnark

EXECUTABLES =

EXECUTABLES_WITH_GTEST =

EXECUTABLES_WITH_SUPERCOP = \
	libsnark/zk_proof_systems/ppzkadsnark/r1cs_ppzkadsnark/examples/demo_r1cs_ppzkadsnark

GTEST_TESTS =

GTEST_SRCS =

DOCS = README.html

LIBSNARK_A = libsnark.a

# For documentation of the following options, see README.md .

ifeq ($(NO_PROCPS),1)
	CXXFLAGS += -DNO_PROCPS
else
	LDLIBS += -lprocps
endif

ifeq ($(LOWMEM),1)
	CXXFLAGS += -DLOWMEM
endif

ifeq ($(PROFILE_OP_COUNTS),1)
	STATIC = 1
	CXXFLAGS += -DPROFILE_OP_COUNTS
endif

ifeq ($(STATIC),1)
ifneq ($(PLATFORM),darwin)
	CXXFLAGS += -static
endif
	CXXFLAGS += -DSTATIC
else
	CXXFLAGS += -fPIC
endif

ifeq ($(MULTICORE),1)
	CXXFLAGS += -DMULTICORE -fopenmp
endif

ifeq ($(CPPDEBUG),1)
        CXXFLAGS += -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC
        DEBUG = 1
endif

ifeq ($(DEBUG),1)
        CXXFLAGS += -DDEBUG -ggdb3
endif

ifeq ($(PERFORMANCE),1)
        OPTFLAGS = -O3 -march=x86-64 -g -mtune=x86-64
        CXXFLAGS += -DNDEBUG
        # Enable link-time optimization:
        CXXFLAGS += -flto -fuse-linker-plugin
        LDFLAGS += -flto
endif

LIB_OBJS  =$(patsubst %.cpp,%.o,$(LIB_SRCS))
EXEC_OBJS =$(patsubst %,%.o,$(EXECUTABLES) $(EXECUTABLES_WITH_GTEST) $(EXECUTABLES_WITH_SUPERCOP))
GTEST_OBJS =$(patsubst %.cpp,%.o,$(GTEST_SRCS))

all: \
     $(if $(NO_GTEST),,$(EXECUTABLES_WITH_GTEST) $(GTEST_TESTS)) \
     $(if $(NO_SUPERCOP),,$(EXECUTABLES_WITH_SUPERCOP)) \
     $(EXECUTABLES) \
     $(LIBSNARK_A) \
     $(if $(NO_DOCS),,doc)

doc: $(DOCS)

$(DEPINST_EXISTS):
	# Create placeholder directories for installed dependencies. Some make settings (including the default) require actually running ./prepare-depends.sh to populate this directory.
	mkdir -p $(DEPINST)/lib $(DEPINST)/include
	touch $@

# In order to detect changes to #include dependencies. -MMD below generates a .d file for each .o file. Include the .d file.
-include $(patsubst %.o,%.d, $(LIB_OBJS) $(GTEST_OBJS) $(EXEC_OBJS) )

$(LIB_OBJS) $(if $(NO_GTEST),,$(GTEST_OBJS)) $(EXEC_OBJS): %.o: %.cpp
	$(CXX) -o $@   $< -c -MMD $(CXXFLAGS)

LIBGTEST_A = $(DEPINST)/lib/libgtest.a

$(LIBGTEST_A): $(GTESTDIR)/libsnark/gtest-all.cc $(DEPINST_EXISTS)
	$(CXX) -o $(DEPINST)/lib/gtest-all.o   -I $(GTESTDIR) -c -isystem $(GTESTDIR)/include $< $(CXXFLAGS)
	$(AR) -rv $(LIBGTEST_A) $(DEPINST)/lib/gtest-all.o

# libsnark.a will contains all of our relevant object files, and we also mash in the .a files of relevant dependencies built by ./prepare-depends.sh
$(LIBSNARK_A): $(LIB_OBJS) $(AR_LIBS)
	$(AR) q $(LIBSNARK_A) $(LIB_OBJS)
	if [ -n "$(AR_LIBS)" ]; then mkdir -p tmp-ar; cd tmp-ar; for AR_LIB in $(AR_LIBS); do $(AR) x $$AR_LIB; done; $(AR) qc $(LIBSNARK_A) tmp-ar/*; cd ..; rm -r tmp-ar; fi;
	$(AR) s $(LIBSNARK_A)

libsnark.so: $(LIBSNARK_A) $(DEPINST_EXISTS)
	$(CXX) -o $@   --shared -Wl,--whole-archive $(LIBSNARK_A) $(CXXFLAGS) $(LDFLAGS) -Wl,--no-whole-archive $(LDLIBS)

libsnark/gadgetlib2/tests/gadgetlib2_test: \
	libsnark/gadgetlib2/tests/adapters_UTEST.cpp \
	libsnark/gadgetlib2/tests/constraint_UTEST.cpp \
	libsnark/gadgetlib2/tests/gadget_UTEST.cpp \
	libsnark/gadgetlib2/tests/integration_UTEST.cpp \
	libsnark/gadgetlib2/tests/protoboard_UTEST.cpp \
	libsnark/gadgetlib2/tests/variable_UTEST.cpp

$(EXECUTABLES): %: %.o $(LIBSNARK_A) $(DEPINST_EXISTS)
	$(CXX) -o $@   $@.o $(LIBSNARK_A) $(CXXFLAGS) $(LDFLAGS) $(LDLIBS)

$(EXECUTABLES_WITH_GTEST): %: %.o $(LIBSNARK_A) $(if $(COMPILE_LIBGTEST),$(LIBGTEST_A)) $(DEPINST_EXISTS)
	$(CXX) -o $@   $@.o $(LIBSNARK_A) $(CXXFLAGS) $(LDFLAGS) $(GTEST_LDLIBS) $(LDLIBS)

$(EXECUTABLES_WITH_SUPERCOP): %: %.o $(LIBSNARK_A) $(DEPINST_EXISTS)
	$(CXX) -o $@   $@.o $(LIBSNARK_A) $(CXXFLAGS) $(LDFLAGS) $(SUPERCOP_LDLIBS) $(LDLIBS)

$(GTEST_TESTS): %: $(GTEST_OBJS) $(LIBSNARK_A) $(if $(COMPILE_LIBGTEST),$(LIBGTEST_A)) $(DEPINST_EXISTS)
	$(CXX) -o $@   $(GTEST_OBJS) $(LIBSNARK_A) $(CXXFLAGS) $(LDFLAGS) $(GTEST_LDLIBS) $(LDLIBS)


ifeq ($(STATIC),1)
LIB_FILE = $(LIBSNARK_A)
else
LIB_FILE = libsnark.so
endif

lib: $(LIB_FILE)

$(DOCS): %.html: %.md
	markdown_py -f $@ $^ -x toc -x extra --noisy
#	TODO: Would be nice to enable "-x smartypants" but Ubuntu 12.04 doesn't support that.
#	TODO: switch to redcarpet, to produce same output as GitHub's processing of README.md. But what about TOC?

ifeq ($(PREFIX),)
install:
	$(error Please provide PREFIX. E.g. make install PREFIX=/usr)
else
HEADERS_SRC=$(shell find libsnark -name '*.hpp' -o -name '*.tcc')
HEADERS_DEST=$(patsubst libsnark/%,$(PREFIX)/include/libsnark/%,$(HEADERS_SRC))

$(HEADERS_DEST): $(PREFIX)/include/libsnark/%: libsnark/%
	mkdir -p $(shell dirname $@)
	cp $< $@

install: $(INSTALL_LIBS) $(HEADERS_DEST) $(DEPINST_EXISTS)
	mkdir -p $(PREFIX)/lib
	cp -v $(INSTALL_LIBS) $(PREFIX)/lib/
ifneq ($(NO_COPY_DEPINST),1)
	cp -rv $(DEPINST)/include $(PREFIX)
endif
endif

check: $(GTEST_TESTS)
	$(GTEST_TESTS)

doxy:
	doxygen doxygen.conf

# Clean generated files, except locally-compiled dependencies
clean:
	$(RM) \
		$(LIB_OBJS) $(GTEST_OBJS) $(EXEC_OBJS) \
		$(EXECUTABLES) $(EXECUTABLES_WITH_GTEST) $(EXECUTABLES_WITH_SUPERCOP) $(GTEST_TESTS) \
		$(DOCS) \
		${patsubst %.o,%.d,${LIB_OBJS} ${GTEST_OBJS} ${EXEC_OBJS}} \
		libsnark.so $(LIBSNARK_A) \
	$(RM) -fr doxygen/ \
	$(RM) $(LIBGTEST_A) $(DEPINST)/lib/gtest-all.o

# Clean all, including locally-compiled dependencies
clean-all: clean
	$(RM) -fr $(DEPSRC) $(DEPINST)

.PHONY: all clean clean-all doc doxy lib install

=== src/tui/requirements.txt ===
configobj==5.0.6
pip==9.0.1
pycurl==7.43.0.2
setuptools==39.0.1
six==1.12.0
slick-bitcoinrpc==0.1.4
ujson==1.35
wheel==0.32.3

=== src/cc/dapps/Makefile ===
# just type make to compile all dapps
all: zmigrate oraclefeed

zmigrate:
	$(CC) zmigrate.c -o zmigrate -lm

oraclefeed:
	$(CC) oraclefeed.c -o oraclefeed -lm

clean:
	rm zmigrate oraclefeed

=== contrib/debian/changelog ===
zcash (2.0.1) stable; urgency=medium

  * 2.0.1 release.

 -- Zcash Company <team@z.cash>  Sun, 14 Oct 2018 13:40:30 -0700

zcash (2.0.1~rc1) stable; urgency=medium

  * 2.0.1-rc1 release.

 -- Zcash Company <team@z.cash>  Mon, 08 Oct 2018 12:40:54 -0700

zcash (2.0.0) stable; urgency=medium

  * 2.0.0 release.

 -- Zcash Company <team@z.cash>  Wed, 15 Aug 2018 17:57:50 -0700

zcash (2.0.0~rc1) stable; urgency=medium

  * 2.0.0-rc1 release.

 -- Zcash Company <team@z.cash>  Thu, 09 Aug 2018 16:56:56 +0000

zcash (1.1.2) stable; urgency=medium

  * 1.1.2 release.

 -- Zcash Company <team@z.cash>  Sun, 01 Jul 2018 20:12:33 -0700

zcash (1.1.2~rc1) stable; urgency=medium

  * 1.1.2-rc1 release.

 -- Zcash Company <team@z.cash>  Fri, 22 Jun 2018 17:03:41 -0700

zcash (1.1.1) stable; urgency=medium

  * 1.1.1 release.

 -- Zcash Company <team@z.cash>  Fri, 25 May 2018 15:49:34 +1200

zcash (1.1.1~rc2) stable; urgency=medium

  * 1.1.1-rc2 release.

 -- Zcash Company <team@z.cash>  Wed, 23 May 2018 09:28:50 -0700

zcash (1.1.1~rc1) stable; urgency=medium

  * 1.1.1-rc1 release.

 -- Zcash Company <team@z.cash>  Sat, 19 May 2018 10:16:14 +1200

zcash (1.1.0) stable; urgency=medium

  * 1.1.0 release.

 -- Zcash Company <team@z.cash>  Wed, 11 Apr 2018 20:15:29 -0600

zcash (1.1.0~rc1) stable; urgency=medium

  * 1.1.0-rc1 release.

 -- Zcash Company <team@z.cash>  Thu, 05 Apr 2018 03:26:17 +0100

zcash (1.0.15) stable; urgency=medium

  * 1.0.15 release.

 -- Zcash Company <team@z.cash>  Wed, 28 Feb 2018 16:58:19 +0000

zcash (1.0.15~rc1) stable; urgency=medium

  * 1.0.15-rc1 release.

 -- Zcash Company <team@z.cash>  Sat, 24 Feb 2018 04:20:05 +0000

zcash (1.0.14) stable; urgency=medium

  * 1.0.14 release.

 -- Zcash Company <team@z.cash>  Wed, 03 Jan 2018 23:54:16 +0100

zcash (1.0.14~rc1) stable; urgency=medium

  * 1.0.14-rc1 release.

 -- Zcash Company <team@z.cash>  Fri, 22 Dec 2017 10:12:41 +0000

zcash (1.0.13) stable; urgency=medium

  * 1.0.13 release.

 -- Zcash Company <team@z.cash>  Mon, 20 Nov 2017 12:31:53 +0000

zcash (1.0.13~rc2) stable; urgency=medium

  * 1.0.13-rc2 release.

 -- Zcash Company <team@z.cash>  Fri, 17 Nov 2017 18:01:08 +0000

zcash (1.0.13~rc1) stable; urgency=medium

  * 1.0.13-rc1 release.

 -- Zcash Company <team@z.cash>  Wed, 15 Nov 2017 00:02:21 +0000

zcash (1.0.12) stable; urgency=medium

  * 1.0.12 release.

 -- Zcash Company <team@z.cash>  Thu, 28 Sep 2017 01:26:44 +0100

zcash (1.0.12~rc1) stable; urgency=medium

  * 1.0.12-rc1 release.

 -- Zcash Company <team@z.cash>  Sat, 23 Sep 2017 10:51:36 +0100

zcash (1.0.11) stable; urgency=medium

  * 1.0.11 release.

 -- Zcash Company <team@z.cash>  Tue, 15 Aug 2017 10:06:25 +0100

zcash (1.0.11~rc1) stable; urgency=medium

  * 1.0.11-rc1 release.

 -- Zcash Company <team@z.cash>  Tue, 01 Aug 2017 17:12:52 +0200

zcash (1.0.10+1) stable; urgency=medium

  * 1.0.10-1 release.

 -- Zcash Company <team@z.cash>  Fri, 23 Jun 2017 19:50:41 -0700

zcash (1.0.10) stable; urgency=medium

  * 1.0.10 release.

 -- Zcash Company <team@z.cash>  Thu, 22 Jun 2017 15:13:04 +1200

zcash (1.0.9) stable; urgency=medium

  * 1.0.9 release.

 -- Zcash Company <team@z.cash>  Wed, 24 May 2017 12:51:06 -0700

zcash (1.0.8+1) jessie; urgency=high

  * 1.0.8-1 release.

 -- Zcash Company <team@z.cash>  Thu, 13 Apr 2017 20:20:37 -0700

zcash (1.0.8) jessie; urgency=medium

  * 1.0.8 release.

 -- Zcash Company <team@z.cash>  Mon, 27 Mar 2017 21:30:07 +0100

zcash (1.0.7+1) jessie; urgency=medium

  * 1.0.7-1 release.

 -- Zcash Company <team@z.cash>  Wed, 08 Mar 2017 13:51:11 -0800

zcash (1.0.7) jessie; urgency=medium

  * 1.0.7 release.

 -- Zcash Company <team@z.cash>  Fri, 03 Mar 2017 20:55:04 -0800

zcash (1.0.6) jessie; urgency=medium

  * 1.0.6 release.

 -- Zcash Company <team@z.cash>  Fri, 10 Feb 2017 10:23:00 -0800

zcash (1.0.5) jessie; urgency=medium

  * 1.0.5 release.

 -- Zcash Company <team@z.cash>  Thu, 19 Jan 2017 19:23:40 -0700

zcash (1.0.4) jessie; urgency=medium

  * 1.0.4 release.

 -- Zcash Company <team@z.cash>  Thu, 15 Dec 2016 16:46:14 +1300

zcash (1.0.3) jessie; urgency=medium

  * 1.0.3 release.

 -- Zcash Company <team@z.cash>  Wed, 17 Nov 2016 15:56:00 -0700

zcash (1.0.2) jessie; urgency=medium

  * 1.0.2 release.

 -- Zcash Company <team@z.cash>  Mon, 07 Nov 2016 19:01:35 -0600

zcash (1.0.1) jessie; urgency=medium

  * 1.0.1 release.

 -- Zcash Company <team@z.cash>  Thu, 03 Nov 2016 23:21:09 -0500

zcash (1.0.0-sprout) jessie; urgency=medium

  * 1.0.0 release.

 -- Zcash Company <team@z.cash>  Fri, 28 Oct 2016 03:00:50 -0700

zcash (1.0.0-rc4) jessie; urgency=medium

  * 1.0.0-rc4 release.

 -- Zcash Company <team@z.cash>  Thu, 27 Oct 2016 13:36:00 +0100

zcash (1.0.0-rc3) jessie; urgency=medium

  * 1.0.0-rc3 release.

 -- Zcash Company <team@z.cash>  Wed, 26 Oct 2016 23:17:03 +0100

zcash (1.0.0-rc2) jessie; urgency=medium

  * 1.0.0-rc2 release.

 -- Zcash Company <team@z.cash>  Sun, 23 Oct 2016 01:51:27 +0100

zcash (1.0.0-rc1) jessie; urgency=medium

  * Initial packaging for Debian.

 -- Zcash Company <team@z.cash>  Mon, 17 Oct 2016 11:47:02 -0700

=== contrib/debian/control ===
Source: komodo
Section: utils
Priority: optional
Maintainer: Komodo Platform <support@komodoplatform.com>
Homepage: https://komodoplatform.com/
Build-Depends: autoconf, automake, bsdmainutils, build-essential,
 git, g++-multilib, libc6-dev, libtool,
 m4, ncurses-dev, pkg-config, python,
 unzip, wget, zlib1g-dev
Vcs-Git: https://github.com/jl777/komodo
Vcs-Browser: https://github.com/jl777/komodo

Package: komodo
Architecture: amd64
Depends: ${shlibs:Depends}
Description: Komodo (KMD) full node. The future is multi-chain.
 This package provides the daemon, komodod, and the CLI tool,
 komodo-cli, to interact with the daemon.
